var VWearGaugeTreeActions = AVTreeActions.extend({

   initialize: function() {
      AVTreeActions.prototype.initialize.call(this);
      var oThis = this;
   },

   render: function() {
      var oDiv = this.$el;
      var oNavDiv = $('<div/>', {'class':'tab2Nav'});
      var oBodyDiv = $('<div/>', {'class':'tab2Body'});
      this.$el.append(oNavDiv);
      this.$el.append(oBodyDiv);
      this.drawNav(oNavDiv);
      this.drawTab(oBodyDiv);
      return this;
   },

   drawNav: function(oNavDiv) {
      var oMNav = new MWearGaugeNav({
         'oReport': this.model.get("oReport"),
         'oDevice': this.model.get("oDevice"),
         'sSelectedTab': this.model.get("sTab"),
         'oSSDDevices': this.model.get("oSSDDevices"),
         'oDevices': this.model.get("oDevices"),
         'oControllers': this.model.get("oControllers")
      });
      this.oVNav = new VWearGaugeNav({ el: oNavDiv, model: oMNav });
   },

   drawTab: function(oBodyDiv) {
      var oModel = new MWearGaugeTab({
         'sDeviceID': this.model.get("sDeviceID"),
         'oSSDDevices': this.model.get("oSSDDevices"),
         'oControllers': this.model.get("oControllers")
      });
      this.oVTab = new VWearGaugeTab({ 
         el: this.loadTab("WearGaugeTab"), 
         model: oModel
      });
   },

   onBackClick: function(e) {
      this.selectChild('overview');
      return false;
   },

   resizeWidth: function() {
      AVTreeActions.prototype.resizeWidth.call(this);
      if (IsDefined(this.oVTab))
      {
         var nWidth = this.model.get("nWidth");
         var oNavDiv = this.$('.tab2Nav');
         var nNavWidth = oNavDiv.outerWidth(true);
         if (oNavDiv.css("display") == "none")
         {
            nNavWidth = 0;
         }
         var oBodyDiv = this.oVTab.$el;
         var nVTabWidth = nWidth - nNavWidth - parseInt(oBodyDiv.css('border-left-width')) - parseInt(oBodyDiv.css('border-right-width')) - 10;

         oBodyDiv.width(nVTabWidth);
         this.oVTab.model.set({
            "nWidth": nVTabWidth
         });
      }
   },
   
   resizeHeight: function() {
      AVTab1.prototype.resizeHeight.call(this);
      var nHeight = this.model.get("nHeight");
      // Resize nav.
      var oNavDiv = this.$('.tab2Nav');
      var nBorderTop = parseInt(oNavDiv.css('border-top-width'));
      var nBorderBottom = parseInt(oNavDiv.css('border-bottom-width'));
      var nNavHeight = nHeight - nBorderTop - nBorderBottom - 20;
      this.oVNav.model.set({
         "nHeight": nNavHeight
      });
      this.oVTab.model.set({
         "nHeight": nNavHeight
      })
   }
   
});