var MSSDsNav = AMTreeNav.extend({

   initialize: function() {
      this.set({
         'sEmptyMsg':'STR_EMPTY_SSDS',
         "sTitle": "STR_SSD_DEVICES"
      })
      AMTreeNav.prototype.initialize.call(this); // getDevices() called.
   },

   getDevices: function(bFetch) {
      this.set({'nFilterDriveNumber':0});
      var oSortList = this.createTempSortList();
      var oFilter = new SALFilter(oSortList.filter);
      var sSelectedDeviceID = '';
      this.set({
         'oSortList':oSortList,
         'oFilter':oFilter,
         'sSelectedDeviceID':sSelectedDeviceID
      });
      // Draw the navigation after getting devices.
      if (bFetch)
      {
         this.trigger("renderNotifyRefreshObservers");
      }
      /*else
      {
         this.trigger("render");
      }*/
   },

   createTempSortList: function() {
      var oTempSortList = {};
      oTempSortList.filter = {};
      oTempSortList.filter.NAME = "STR_SHOW";
      oTempSortList.filter.FILTER_VALUES = [];
      oTempSortList.filter.FILTER_VALUES[0] = this.createFilterValues();
      return oTempSortList;
   },

   createFilterValues: function() {
      var oFilterValues = {};
      oFilterValues.NAME = "STR_ALL";
      oFilterValues.GROUPS = [];
      oFilterValues.GROUPS[0] = this.createSingleGroup();
      return oFilterValues;
   },

   createSingleGroup: function() {
      var oSingleGroup = {};
      var oControllerIDs = this.get('oControllerIDs');
      oSingleGroup.NAME = "STR_CONTROLLER";
      oSingleGroup.GROUP_VALUES = [];
      for (var i=0; i<oControllerIDs.length; ++i)
      {
         oSingleGroup.GROUP_VALUES[i] = this.createControllerGroupValues(oControllerIDs[i]);
      }
      return oSingleGroup;
   },

   createControllerGroupValues: function(sCtrlID) {
      var oControllerGroupValues = {};
      oControllerGroupValues.NAME = sCtrlID;
      oControllerGroupValues.SORT_LISTS = [];
      oControllerGroupValues.SORT_LISTS[0] = this.createSortList(sCtrlID);
      return oControllerGroupValues;
   },

   createSortList: function(sCtrlID) {
      var oChildSSDIDs = EnumerateDevices("TypeSolidStateDevice", sCtrlID).devices;
      var nFilterDriveNumber = this.get("nFilterDriveNumber");
      var oSortList = {};
      var aSortList = [];
      for (var i=0; i<oChildSSDIDs.length; ++i)
      {
         aSortList[i] = nFilterDriveNumber;
         ++nFilterDriveNumber;
      }
      this.set({"nFilterDriveNumber":nFilterDriveNumber})
      oSortList.NAME = "STR_NONE";
      oSortList.SORTLIST = aSortList;
      return oSortList;
   },

   removeEmptyControllers: function(oSingleGroup) {
      var oGroupValues = oSingleGroup.GROUP_VALUES;
      var oGoodValues = [];
      for (var i=0; i<oGroupValues.length; ++i) {
         if(oGroupValues[i].SORT_LISTS[0].SORTLIST.length != 0) {
            oGoodValues.push(oGroupValues[i]);
         }
      }
      oSingleGroup.GROUP_VALUES = oGoodValues;
      return oSingleGroup;
   }

});