var VSSDsNav = AVTreeNav.extend({
   
   getNumDevices: function() {
      return this.model.get('oDevices').length;
   },

   drawDevices: function() {
      // Don't attempt do draw anything if there are no devices.
      if (this.getNumDevices() > 0)
      {
         var oFilter = this.model.get('oFilter');
         var oFilterGroupsDiv = this.$('.filterGroups').empty();
         var oCurrentValues = this.model.get('oAttributes');
         if (IsDefined(oCurrentValues))
         {
            oCurrentValues = oCurrentValues.CURRENT_VALUE;
            if (IsDefined(oCurrentValues))
            {
               oCurrentValues = oCurrentValues.split('|');
            }
         }
         var oDevices = this.model.get('oDevices');
         for ( var gvIndex = 0; gvIndex < oFilter.numGroupValues(); ++gvIndex )
         {
            oFilter.SelectGroupValue( gvIndex );
            oFilter.SelectSortList();
            var oSortList = oFilter.sortList();
            var sGroupName = oFilter.groupName();
            var sGroupValueName = oFilter.groupValueName();
            var sControlName = "Control Name goes here";//this.getName();
            var sGroupID = 'filterGroup' + gvIndex;
            //var oCurrentValues = this.model.get('oCurrentValues');
            var sType = this.model.get('sType');
            // Create an array with the usage remaining
            var oUsageRemaining = {};
            var oSSDStatus = {};
            for (var i=0; i<oDevices.length; ++i)
            {
               var sSSDID = oDevices[i];
               var oDetails = GetDeviceSection(sSSDID, "STR_PHYSICAL_DRIVE_DETAILS");
               var sStatus = GetSectionAttribute(oDetails, "STR_SSD_STATUS_MESSAGE");
               if (IsDefined(sStatus) && sStatus != "ATTR_VALUE_STATUS_NOT_SUPPORTED")
               {
                  var nStatus = 999;
                  if (sStatus == 'STR_MSG_SSD_SMART_TRIP')
                  {
                     nStatus = 2;
                  }
                  else if (sStatus == 'STR_MSG_SSD_56DAY_WARNING' ||
                           sStatus == 'STR_MSG_SSD_56_DAY_5PERCENT_LIFE_REMAINING' ||
                           sStatus == 'STR_MSG_SSD_56_DAY_2PERCENT_LIFE_REMAINING' ||
                           sStatus == 'STR_MSG_SSD_5PERCENT_LIFE_REMAINING' || 
                           sStatus == 'STR_MSG_SSD_2PERCENT_LIFE_REMAINING')
                  {
                     nStatus = 3;
                  }
                  else
                  {
                     nStatus = 4;
                  }
                  oSSDStatus[sSSDID] = nStatus;
                  var nUtilization = GetSectionAttribute(oDetails, "ATTR_NAME_EXINFO_SSD_UTILIZATION");
                  if (IsDefined(nUtilization))
                  {
                     nUtilization = parseFloat(nUtilization);
                     if (nUtilization > 100)
                     {
                        nUtilization = 100;
                     }
                     if (nUtilization >= 0)
                     {
                        oUsageRemaining[sSSDID] = 100 - nUtilization;
                     }
                  }
               }
            }
            var oMTreeDeviceSelectorGroup = new MTreeDeviceSelectorGroup({
               'oSortList':oSortList,
               'sGroupName':sGroupName,
               'sGroupValueName':sGroupValueName,
               //'sControlName':sControlName,
               'oDevices':oDevices,
               'oCurrentValues':oCurrentValues,
               //'sType':sType,
               'oUsageRemaining':oUsageRemaining,
               'oSSDStatus':oSSDStatus,
               'bGroupSelectable':false,
               'bHideEmptyParents':true
            });
            var oVTreeDeviceSelectorGroup = new VTreeDeviceSelectorGroup({
               'id':sGroupID,
               'model':oMTreeDeviceSelectorGroup
            });
            oFilterGroupsDiv.append(oVTreeDeviceSelectorGroup.$el);
         }
         // Highlight selected.
         //this.highlightChild();
         this.resize();
      }
   }
   
});