var VControlRadioDevices = AVControl.extend({

   events: {
      "change input[type=radio]" : "radioChanged"
   },
   
   initialize: function() {
      AVControl.prototype.initialize.call(this);
   },
   
   render: function() {
      var oRadioDiv = $('<div/>', {'class': "radioWrapper"});
      $(this.el).append(oRadioDiv);
      this.drawRadio();
      this.drawDevices();
      return this;
   },
   
   getValue: function() {
      var s = '';
      s = this.$('input[name=' + this.model.get("sName") + ']:checked').val();
      return s;
   },
   
   drawRadio: function() {
      var oRadioDiv = this.$('.radioWrapper');
      var oValues = this.model.get("oValues");
      var oAttributes = this.model.get("oAttributes");
      var sCurrentValue = oAttributes.CURRENT_VALUE;
      var sDefaultValue = oAttributes.DEFAULT_VALUE;
      if (!IsDefined(sCurrentValue))
      {
         sCurrentValue = sDefaultValue;
      }
      var hasCurrentValue = IsDefined(sCurrentValue);
      var sName = this.model.get("sName");
      for (var i=0; i < oValues.length; ++i)
      {
         var oRadioInputDiv = $('<div/>', {'class': "radioInputWrapper"});
         var sID = sName + i;
         var oRadioInput = $('<input/>', 
         {
            'id': sID,
            'class': "radioInput popupTabbable",
            'type': "radio",
            'name': sName,
            'value': oValues[i]
         });
         var oRadioInputLabel = $('<label/>',
         {
            'for': sID,
            'class': "radioInputLabel"
         });
         oRadioInputLabel.html(TranslateString(oValues[i]));
         oRadioInputDiv.append(oRadioInput);
         oRadioInputDiv.append(oRadioInputLabel);
         oRadioDiv.append(oRadioInputDiv);
         if (oValues[i] == sCurrentValue)
         {
            oRadioInput.prop("checked", true);
         }
      }
   },

   drawDevices: function() {
      var oRadioDiv = this.$('.radioWrapper');
      var oAttributes = this.model.get("oAttributes");
      var oContainedDevices = oAttributes.CONTAINED_DEVICES;
      if (IsDefined(oContainedDevices))
      {
         oContainedDevices = oContainedDevices.split('|');
      }
      var nNumDevices = oContainedDevices.length;
      if (nNumDevices > 0)
      {
      	var oDevicesDiv = $('<div/>', {'class': "devicesWrapper"});
      	var oTable = $('<table/>');
      	var oTR;
      	var nNumColumns = 4;
      	oDevicesDiv.append(oTable);
	      for (var i=0; i<nNumDevices; ++i)
	      {
	      	if (i%nNumColumns == 0)
	      	{
	      		oTR = $('<tr/>');
	      		oTable.append(oTR);
	      	}
	      	var oTD = $('<td/>');
	      	var oDeviceLabelDiv = $('<div/>', {'class': 'deviceLabel item'});
	         oTD.append(oDeviceLabelDiv);
	         oTR.append(oTD);
	         var oMDeviceLabel = new MDeviceLabel({
	            'sDeviceID':oContainedDevices[i]
	         });
	         var oVDeviceLabel = new VDeviceLabel({
	            'model':oMDeviceLabel,
	            'el': oDeviceLabelDiv
	         });
	      }
      	oRadioDiv.append(oDevicesDiv);
	   }
   },
   
   radioChanged: function(e) {
      this.model.set({
         'sValue': this.$('input[name=' + this.model.get("sName") + ']:checked').val()
      });
   }
});