var AVTabLink = BaseView.extend({
   
   events: {
   },
   
   initialize: function() {
      this.model.on('change:nCount', this.onChangeCount, this);
      this.model.on('change:nStatusCount', this.render, this);
      this.model.on('change:sStatusCountClass', this.render, this);
      this.model.on('change:bUpdated', this.render, this);
      this.model.update();
   },

   dispose: function() {
      this.disposeTooltips();
   },
   
   render: function() {
      this.$el.empty();
      var sName = this.model.get("sName");
      var sIcon = this.model.get("sIcon");
      var sTranslatedName = TranslateString(sName);
      var bEnabled = true || this.model.get("bAlwaysEnabled") || (nCount > 0);
      var sIconClass = sIcon;
      if (!bEnabled)
      {
         sIconClass += "_GRAYSCALE";
      }
      var sLinkPrefix = this.model.get("sLinkPrefix");
      var sLink = "#" + sLinkPrefix;
      var sEndLink = this.model.get("sLink");
      if (IsDefinedAndSet(sEndLink))
      {
         if (IsDefinedAndSet(sLinkPrefix))
         {
            sLink += "/";
         }
         sLink += this.model.get("sLink");
      }
      var oIconDiv = $('<div/>', {
         'class': 'icon HPSSA_SPRITE ' + sIconClass
      });
      
      // Add status overlay icon.
      /*var sIconStatusOverlayClass = this.model.get('sIconStatusOverlayClass');
      if (IsDefinedAndSet(sIconStatusOverlayClass) && sIconStatusOverlayClass != 'HPSSA_SPRITE iconOverlay ICON_OVERLAY_STATUS_OK')
      {
         var oIconOverlay = $('<div/>', {'class':sIconStatusOverlayClass});
         oIconDiv.append(oIconOverlay);
      }*/

      // Add Status Icon Overlay if device does not have OK status.
      var oIconOverlayDiv = $('<div/>', {'class': 'iconOverlay'});;
      var sIconStatusOverlayClass = this.model.get('sIconStatusOverlayClass');
      if (IsDefinedAndSet(sIconStatusOverlayClass) && sIconStatusOverlayClass != "ICON_OVERLAY_STATUS_OK")
      {
         oIconOverlayDiv.addClass('HPSSA_SPRITE');
         oIconOverlayDiv.addClass(sIconStatusOverlayClass);
      }
      // Add empty div as placeholder in case a state icon overlay exists.
      oIconDiv.append(oIconOverlayDiv);
      
      // Add State Icon Overlya (i.e. encrypted device) if one exists
      var sIconStateOverlayClass = this.model.get('sIconStateOverlayClass');
      if (IsDefinedAndSet(sIconStateOverlayClass))
      {
         var oIconStateOverlayDiv = $('<div/>', {'class': 'iconStateOverlay HPSSA_SPRITE ' + sIconStateOverlayClass});
         oIconDiv.append(oIconStateOverlayDiv);
      }
      
      // Add status count.
      var nCount = this.model.get("nCount");
      var nStatusCount = this.model.get("nStatusCount");
      var bDisplayStatus = nStatusCount > 0;
      var sStatusCountClass = this.model.get("sStatusCountClass");
      var oStatusDiv;
      var sDeviceCount = '';
      var sType = this.model.get("sType");
      var bShowCount = sType != "TypeCacheManager" && sType != "TypeLicenseManager" && sType != "TypeEncryptionManager";
      if (nCount > 0 && bShowCount)
      {
         sDeviceCount = ' (' + nCount + ')';
      }
      if (bDisplayStatus)
      {
         oStatusDiv = $('<div/>', {
            'class': 'count ' + sStatusCountClass
         });
         oStatusDiv.html(nStatusCount);
      }
      var sLabelClass;
      var sLabel;
      var oLabelDiv = $('<div/>');
      var sDescription = TranslateString(this.model.get("sDescription"));
      var sDeviceID = this.model.get('sDeviceID');
      if (sType == "TypeLogicalArray")
      {
         // nCount contains the array count.
         sLabel = (nCount == 1) ? "STR_ARRAY_COUNT_SINGULAR" : "STR_ARRAY_COUNT_PLURAL";
         sDescription = TranslateString(sLabel + "|" + nCount);
         var oLDs = EnumerateDevices("TypeLogicalDrive", sDeviceID);
         var nLDCount = oLDs.devices.length;
         var sLDLabel = (nLDCount == 1) ? "STR_LOGICAL_DRIVE_COUNT_SINGULAR" : "STR_LOGICAL_DRIVE_COUNT_PLURAL";
         sDescription += ", " + TranslateString(sLDLabel + "|" + nLDCount);
      }
      else if (sType == "TypePhysicalDevices")
      {
         var oPDs = EnumerateDevices("TypePhysicalDrive", sDeviceID);
         var nPDCount = oPDs.devices.length;
         sLabel = (nPDCount == 1) ? "STR_PHYSICAL_DRIVE_COUNT_SINGULAR" : "STR_PHYSICAL_DRIVE_COUNT_PLURAL";
         sDescription = TranslateString(sLabel + "|" + nPDCount);
      }
      else if (sType == "TypeUnassignedDrive")
      {
         // nCount contains the array count.
         sLabel = (nCount == 1) ? "STR_UNASSIGNED_DRIVE_COUNT_SINGULAR" : "STR_UNASSIGNED_DRIVE_COUNT_PLURAL";
         sDescription = TranslateString(sLabel + "|" + nCount);
      }
      else if (sType == "TypeEncryptionManager")
      {
         // Add a second line for the encryption status
         var section = GetDeviceIDSection(sDeviceID + ":EM", true);
         var sStatus = section.ENCRYPTION_STATUS;
         var sLoggedIn = section.LOGGED_IN;
         var sDesc = "";
         // Line will say Encryption Not Set or Express Local Encryption
         if (sLoggedIn == "STR_ENCRYPTION_NOT_SET" || sLoggedIn == "STR_ENCRYPTION_ONE_BUTTON_MODE")
         {
            sDesc = sLoggedIn;
         }
         else if (sLoggedIn == "STR_ENCRYPTION_NOT_LOGGED_IN" || 
                  sLoggedIn == "STR_ENCRYPTION_LOGGED_IN_AS_CRYPTO" ||
                  sLoggedIn == "STR_ENCRYPTION_LOGGED_IN_AS_USER")
         {
            if (sStatus == "ATTR_VALUE_ENCRYPTION_ENABLED_TRUE")
            {
               // Line will say Encryption Enabled
               sDesc = "STR_ENCRYPTION_ENABLED";
            }
            else
            {
               // Line will say Encryption Disabled
               sDesc = "STR_ENCRYPTION_DISABLED_TITLE";
            }
         }
         sDescription = TranslateString(sDesc);
      }
      if (sDescription != '')
      {
         sLabelClass = 'labelPlural';
         
         // Add name to label.
         var oNameDiv = $('<div/>', {
            'class': 'name'
         });
         oNameDiv.html(sTranslatedName);
         oLabelDiv.append(oNameDiv);
         
         // Add description to label.
         var oDescDiv = $('<div/>', {
            'class': 'description'
         });
         oDescDiv.html(sDescription);
         oLabelDiv.append(oDescDiv);
      }
      else
      {
         sLabelClass = 'label';
         oLabelDiv.html(sTranslatedName + sDeviceCount);
      }
      oLabelDiv.addClass(sLabelClass);
      var oContainer;
      var sAClass = "link";
      if (bEnabled)
      {
         var sSelectedClass = this.model.get("bSelected") ? ' selected' : '';
         sAClass += sSelectedClass;
         oContainer = $('<a/>', {
            'href': sLink,
            'id': sName,
            'class': sAClass
         });
      }
      else
      {
         sAClass += ' disabledLink';
         oContainer = $('<div/>', {
            'class': sAClass,
            'id': sName
         });
      }
      oContainer.append(oIconDiv);
      oContainer.append(oLabelDiv);
      // Display Status Count.
      if (bDisplayStatus)
      {
         oContainer.append(oStatusDiv);
         // Add ToolTip.
         var oToolTip = $('<div/>', {'class':'tooltip'});
         var oDevice = this.model.get('oDevice');
         var oMDeviceStatus = new MDeviceStatus({
            'oDevice':oDevice,
            'nDetailLevel':2
         });
         var oVDeviceStatus = new VDeviceStatus({
            'className':'popupDetails',
            'model':oMDeviceStatus
         });
         var jBoxOptions = {
            'attach': oStatusDiv,
            'content': oVDeviceStatus.$el,
            'position': {
               'x': "right",
               'y': "top"
            },
            'zIndex':10000000,
            'addClass': "tooltip",
            'trigger': "mouseenter",
            'closeOnMouseleave': true,
            'maxWidth': 700,
            'minWidth': 100,
            'adjustPosition': true,
            'adjustTracker':true,
            'adjustDistance': 5,
            'outside': "x",
            'fade':false,
            'delayClose':50,

         };
         this.addToTooltips(new jBox(jBoxOptions));


         /*oToolTip.append(oVDeviceStatus.$el);
         oToolTip.hide();
         oContainer.append(oToolTip);
         oStatusDiv.tooltip({
            //"offset": [110, 2],
            "position": "bottom right"
         });*/
         var oThis = this;
         oStatusDiv.click(function(){
            var oMStatusPopup = new MStatusPopup({
               'sDeviceID': oThis.model.get('sDeviceID'),
               'oDevice': oThis.model.get('oDevice')
            });
            var oVStatusPopup = new VStatusPopup({
               'model': oMStatusPopup
            });
            oThis.$el.trigger("popup", {
               'sType': 'statusPopup',
               'oVContent': oVStatusPopup,
               'bClickOutsideToClose':true
            });
            return false;
         });
      }
      this.$el.append(oContainer);
      return this;
   },
   
   onChangeCount: function() {
      this.render();
   }
});
_.defaults(AVTabLink.prototype, MixinTooltips());
