// Contains Tab Links (AVTabLink)
var VTabSection = BaseView.extend({
   
   events: {
   },
   
   initialize: function() {
      this.oVTabLinks = [];
      this.render();
   },
   
   render: function() {
      this.$el.empty();
      var oUL = $('<ul/>', {'class':'list1'});
      this.$el.append(oUL);
      return this;
   },

   dispose: function() {
      for (var i=0; i<this.oVTabLinks.length; ++i)
      {
         this.oVTabLinks[i].dispose();
      }
      this.oVTabLinks = [];
   },

   addNote: function(sMessage)
   {
      var oUL = this.$('.list1');
      var oLI = $('<li class="note"></li>');
      oLI.append(TranslateString(sMessage));
      oUL.append(oLI);
   },

   drawTabLink: function(sLinkPrefix, sDeviceID, bSelected)
   {
      var oUL = this.$('.list1');
      var oLI = $('<li class="item1"></li>');
      oUL.append(oLI);
      var oMTabLink = new MSSDSTabLink({
         "sDeviceID":sDeviceID,
         "sLinkPrefix":sLinkPrefix,
         "bSelected":bSelected
      });
      var oVTabLink = new VSSDSTabLink({
         el: oLI,
         model: oMTabLink
      });
      this.oVTabLinks.push(oVTabLink);
   },
   
   drawServerTabLink: function(sLinkPrefix, sDeviceID, bSelected)
   {
      var oUL = this.$('.list1');
      var oLI = $('<li class="item1"></li>');
      oUL.append(oLI);
      var oMTabLink = new MServerTabLink({
         "sDeviceID":sDeviceID,
         "sLinkPrefix":sLinkPrefix,
         "bSelected":bSelected
      });
      var oVTabLink = new VServerTabLink({
         el: oLI,
         model: oMTabLink
      });
      this.oVTabLinks.push(oVTabLink);
   },
   
   drawConfigurationDeviceTabLink: function(sLinkPrefix, sDeviceID, oDevice, bSelected)
   {
      var oUL = this.$('.list1');
      var oLI = $('<li class="item1"></li>');
      oUL.append(oLI);
      var oMTabLink = new MConfigurationDeviceTabLink({
         'sDeviceID':sDeviceID,
         'oDevice':oDevice,
         'sLinkPrefix':sLinkPrefix,
         'bSelected':bSelected
      });
      var oVTabLink = new VConfigurationDeviceTabLink({
         el: oLI,
         model: oMTabLink
      });
      this.oVTabLinks.push(oVTabLink);
   },
   
   drawDeviceContainerTabLink: function(sLinkPrefix, sDeviceID, sIcon, sName, sLink, sType, nCount, bSelected)
   {
      var oUL = this.$('.list1');
      var oLI = $('<li class="item1"></li>');
      oUL.append(oLI);
      var oMTabLink = new MConfigurationContainerTabLink({
         "sDeviceID":sDeviceID,
         "sIcon":sIcon,
         "sName":sName,
         "sLink":sLink,
         'sLinkPrefix':sLinkPrefix,
         "sType":sType,
         "nCount":nCount,
         "bSelected":bSelected
      });
      var oVTabLink = new VConfigurationContainerTabLink({
         el: oLI,
         model: oMTabLink
      });
      oVTabLink.render();
      this.oVTabLinks.push(oVTabLink);
   }
   
});